#!/usr/bin/python
#
###########
#
#Name:lighting_flashes_strikes.py
#Description:flash LED to simulate lighting including ground strike
#Date: March 24, 2019
#Revision:1.0
#
###########

import time					# provides various time-related functions
import RPi.GPIO as GPIO		# provides interface to input/output pins of the Pi
import random
import os


# setup GPIO
GPIO.setwarnings(False)
GPIO.setmode(GPIO.BOARD)           # set option to reference physical pins

# GPIO pin definitions
IO_2 = 3  # Define GPIO pin
IO_3 = 5  # Define GPIO pin
IO_4 = 7  # Define GPIO pin
IO_5 = 29  # Define GPIO pin
IO_6 = 31  # Define GPIO pin
IO_7 = 26  # Define GPIO pin
IO_8 = 24  # Define GPIO pin
IO_9 = 21  # Define GPIO pin
IO_10 = 19  # Define GPIO pin
IO_11 = 23  # Define GPIO pin
IO_12 = 32  # Define GPIO pin
IO_13 = 33  # Define GPIO pin
IO_14 = 8  # Define GPIO pin
IO_15 = 10  # Define GPIO pin
IO_16 = 36  # Define GPIO pin
IO_17 = 11  # Define GPIO pin
IO_18 = 12  # Define GPIO pin
IO_19 = 35  # Define GPIO pin
IO_20 = 38  # Define GPIO pin
IO_21 = 40  # Define GPIO pin
IO_22 = 15  # Define GPIO pin
IO_23 = 16  # Define GPIO pin
IO_24 = 18  # Define GPIO pin
IO_25 = 22  # Define GPIO pin
IO_26 = 37  # Define GPIO pin
IO_27 = 13  # Define GPIO pin

IO_array = (
    IO_2, IO_3, IO_4, IO_5,
    IO_6, IO_7, IO_8, IO_9,
    IO_10, IO_11, IO_12, IO_13,
    IO_14, IO_15, IO_16, IO_17,
    IO_18, IO_19, IO_20, IO_21,
    IO_22, IO_23, IO_24, IO_25,
    IO_26, IO_27
)

IO_array_light = (
    IO_2, IO_3, IO_4,
    IO_5, IO_6, IO_7
)

# Set GPIO function
GPIO.setup(IO_array_light, GPIO.OUT)  # set GPIO pins for lighting output

def flashHZ (GPIOpin):
    High_HZ = random.uniform(0,.3)
    Low_HZ = random.uniform(1,2)
    GPIO.output(GPIOpin, GPIO.HIGH)# set HIGH (LED ON)
    time.sleep(High_HZ)		           # wait
    GPIO.output(GPIOpin, GPIO.LOW) # set LOW (LED OFF)
    time.sleep(Low_HZ)          	   # wait
    return

def flashHZ_GND (GPIOpin):
    High_HZ = random.uniform(0,1.5)
    Low_HZ = random.uniform(1,2)
    GPIO.output(GPIOpin, GPIO.HIGH)# set HIGH (LED ON)
    time.sleep(High_HZ)		           # wait
    GPIO.output(GPIOpin, GPIO.LOW) # set LOW (LED OFF)
    time.sleep(Low_HZ)          	   # wait
    return

try:
    while True:
        strike = random.choice(IO_array_light) #pick a LED from lighting list

        #test to determine if lighting is ground strike or air strike
        if (strike == 3):
            print("Ground Strike!",strike)
            flashHZ_GND(strike)
        else:
            print("Cloud Strike.", strike)
            flashHZ(strike)

except KeyboardInterrupt:  # if ctrl+c pressed exit cleanly
    GPIO.cleanup()
except:  # this catches ALL other exceptions including errors.
    GPIO.cleanup()
finally:  # cleanup GPIO on normal exit
    GPIO.cleanup()

