package main

import (
	"flag"
	"fmt"

	"github.com/hashicorp/vault/api"
)

var vault_addr = "http://127.0.0.1:8200"

func main() {
	flag.Parse()

	if len(flag.Args()) < 3 {
		fmt.Printf("usage: token path key\n")
		return
	}

	token := flag.Args()[0]
	path := flag.Args()[1]
	key := flag.Args()[2]

	config := &api.Config{
		Address: vault_addr,
	}

	client, err := api.NewClient(config)
	if err != nil {
		fmt.Println(err)
		return
	}

	client.SetToken(token)

	secret, err := client.Logical().Read("secret/data" + "/" + path)

	if err != nil {
		fmt.Println(err)
		return
	}

	m, found := secret.Data["data"].(map[string]interface{})
	if !found {
		fmt.Printf("%T %#v\n", secret.Data["data"], secret.Data["data"])
		return
	}

	fmt.Printf("%v: %v\n", key, m[key])
}
